#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "funcadd.h"


void printarray(AmplExports *ae, real *a,int n)
{
  int i;

  for(i=0;i<n;i++)
    fprintf(Stderr,"%.10lf ", a[i]);
  fprintf(Stderr,"\n\n");
}



void printmatrix(AmplExports *ae, real *m, int n1, int n2)
{
  int i;

  for(i=0;i<n1;i++)
    printarray(ae, m+n2*i, n2);
}

/* sort ascending */
void sort(int n, double *data)
{
	int i,j;
	double tmp;
	
	for(i=0;i<n;i++){
		for(j=0;j<n-i-1;j++)
			if(data[j]>data[j+1]){ /* exchange */
				tmp=data[j];
				data[j]=data[j+1];
				data[j+1]=tmp;
			}
	}
	
	
	return;
}


/************************************************
Objective function for median
************************************************/
static double median(arglist *al)
{
  double *data;
  AmplExports *ae = al->AE;

  if (al->n < 2){
    fprintf(Stderr, "Invalid number of args to ecoli expected >=2 and obtained %d\n", al->n);
    return 0.0;
  }

  data=malloc((al->n)*sizeof(double));

  memcpy(data, al->ra, (al->n)*sizeof(double));

  sort(al->n, data); /* buble sort in data */


 /* printarray(ae,data,al->n); */


  if((al->n)%2==0){ /* median is average */
	  /*printf("Average of %f %f\n", data[(int)al->n/2-1], data[((int)al->n/2)]); */
    return (data[(int)al->n/2-1]+data[((int)al->n/2)])/2;
  } else {
	  /*printf("%f", data[(int)al->n/2]); */
    return (data[(int)al->n/2]);
  };
}


void
funcadd(AmplExports *ae){
  /* Insert calls on addfunc here... */
  /* Arg 3, called argtype, can be 0 or 1:
   *	0 ==> force all arguments to be numeric
   *	1 ==> pass both symbolic and numeric arguments.
   *
   * Arg 4, called nargs, is interpretted as follows:
   *	>=  0 ==> the function has exactly nargs arguments
   *	<= -1 ==> the function has >= -(nargs+1) arguments.
   *
   * Arg 5, funcinfo, is passed to the functions in struct arglist;
   *	it is not used in these examples, so we just pass 0.
   */
  
  addfunc("median", (ufunc*)median, 0, -3, 0);
}
